import { SetupContext, EmitsOptions, VNode, Component, ConcreteComponent } from 'vue';
import { StyledElementTags } from './tags.js';
import '@chakra-ui/utils';

type StyledOptions = {
    __label?: string;
    target?: string;
};
type Interpolations = Array<any>;
type StyledComponent<Props> = (_: unknown, { attrs, expose, slots }: SetupContext<EmitsOptions>) => VNode & {
    __emotion_real: StyledComponent<Props>;
    __emotion_base: any;
    __emotion_styles: any;
    __emotion_forwardProp: any;
    withComponent: CreateStyled;
};
type StyledTagOrComponent = StyledElementTags | Component | ConcreteComponent | string;
type StyledElementType<Props> = string | StyledComponent<Props & {
    class: string;
}> | Component<Props & {
    class: string;
}>;
type PrivateStyledComponent<Props> = StyledComponent<Props> & {
    __emotion_real: StyledComponent<Props>;
    __emotion_base: any;
    __emotion_styles: any;
    __emotion_forwardProp: any;
    withComponent: CreateStyled;
};
type CreateStyledComponent = <Props>(...args: Interpolations) => StyledComponent<Props>;
type CreateStyled = {
    <Props>(tag: StyledElementType<Props>, options?: StyledOptions): (...args: Interpolations) => StyledComponent<Props>;
    [key: string]: CreateStyledComponent;
    bind: () => CreateStyled;
} & {
    [key in StyledElementTags]: <Props>(...args: any[]) => PrivateStyledComponent<Props>;
};

export { CreateStyled, CreateStyledComponent, Interpolations, PrivateStyledComponent, StyledComponent, StyledElementType, StyledOptions, StyledTagOrComponent };
